package net.shadowfacts.phycon.plugin.techreborn

import alexiil.mc.lib.attributes.AttributeList
import alexiil.mc.lib.attributes.AttributeSourceType
import alexiil.mc.lib.attributes.item.GroupedItemInv
import alexiil.mc.lib.attributes.item.ItemAttributes
import net.fabricmc.api.ModInitializer
import net.minecraft.block.BlockState
import net.minecraft.util.math.BlockPos
import net.minecraft.world.World
import techreborn.blockentity.storage.item.StorageUnitBaseBlockEntity
import techreborn.init.TRContent

/**
 * @author shadowfacts
 */
object PhyConTR: ModInitializer {

	override fun onInitialize() {
		TRContent.StorageUnit.values().forEach {
			ItemAttributes.GROUPED_INV.setBlockAdder(AttributeSourceType.COMPAT_WRAPPER, it.block, ::addStorageUnitGroupedInv)
		}
	}

	private fun addStorageUnitGroupedInv(world: World, pos: BlockPos, state: BlockState, to: AttributeList<GroupedItemInv>) {
		(world.getBlockEntity(pos) as? StorageUnitBaseBlockEntity)?.also { su ->
			to.offer(StorageUnitWrapper(su))
		}
	}

}
